import React, { Component } from 'react'
import { Button, Card, Form, Input, message as Message, Popconfirm, Radio } from 'antd'
import {
    AntIcon,
    Auth,
    Container,
    ModalForm,
    QueryTable,
    QueryTableActions,
    QueryTreeLayout,
} from 'components'
import { api } from 'common/api'
import auth from 'components/authorized/handler'
import { toCamelCase } from 'util/format'
import { isEqual } from 'lodash'
import getDictData from 'util/dic'
import FormBody from './form'
import DictData from './dictdata'

const apiAction = {
    tree: api.sysDictTypeTree,
    page: api.sysDictTypePage,
    add: api.sysDictTypeAdd,
    edit: api.sysDictTypeEdit,
    delete: api.sysDictTypeDelete,
}

const name = '字典'

export default class index extends Component {
    state = {
        codes: {
            commonStatus: [],
        },
    }

    // 表格实例
    table = React.createRef()

    // 新增窗口实例
    addForm = React.createRef()
    // 编辑窗口实例
    editForm = React.createRef()

    // 树选中节点
    selectId = undefined

    // 表格字段
    columns = [
        {
            title: '字典名称',
            dataIndex: 'name',
            width: 200,
            sorter: true,
        },
        {
            title: '类型',
            key: 'type',
            dataIndex: 'code',
            width: 120,
            sorter: true,
            render: text => (text ? '字典类型' : '目录'),
        },
        {
            title: '唯一编码',
            dataIndex: 'code',
            width: 120,
            sorter: true,
        },
        {
            title: '排序',
            dataIndex: 'sort',
            width: 80,
            sorter: true,
            defaultSortOrder: 'ascend',
        },
        {
            title: '备注',
            dataIndex: 'remark',
            width: 200,
            sorter: true,
        },
        {
            title: '状态',
            dataIndex: 'status',
            width: 80,
            sorter: true,
            render: text => this.bindCodeValue(text, 'common_status'),
        },
    ]

    /**
     * 构造函数,在渲染前动态添加操作字段等
     * @param {*} props
     */
    constructor(props) {
        super(props)

        const flag = auth({ sysDict: [['edit'], ['delete']] })

        if (flag) {
            this.columns.push({
                title: '操作',
                width: 150,
                dataIndex: 'actions',
                render: (text, record) => (
                    <QueryTableActions>
                        <Auth auth="sysDict:edit">
                            <a onClick={() => this.onOpen(this.editForm, record)}>编辑</a>
                        </Auth>
                        <Auth auth="sysDict:delete">
                            <Popconfirm
                                placement="topRight"
                                title="是否确认删除"
                                onConfirm={() => this.onDelete(record)}
                            >
                                <a>删除</a>
                            </Popconfirm>
                        </Auth>
                    </QueryTableActions>
                ),
            })
        }
    }

    /**
     * 阻止外部组件引发的渲染,提升性能
     * 可自行添加渲染条件
     * [必要]
     * @param {*} props
     * @param {*} state
     * @returns
     */
    shouldComponentUpdate(props, state) {
        return !isEqual(this.state, state)
    }

    /**
     * 加载字典数据,之后开始加载表格数据
     * 如果必须要加载字典数据,可直接对表格设置autoLoad=true
     */
    componentDidMount() {
        this.table.current.onLoading()
        getDictData('common_status').then(res => {
            this.setState(
                {
                    codes: res,
                },
                () => {
                    this.table.current.onLoadData()
                }
            )
        })
    }

    /**
     * 调用加载数据接口,可在调用前对query进行处理
     * [异步,必要]
     * @param {*} params
     * @param {*} query
     * @returns
     */
    loadData = async (params, query) => {
        query = {
            ...query,
            pid: this.selectId,
        }

        const { data } = await apiAction.page({
            ...params,
            ...query,
        })
        return data
    }

    /**
     * 调用树结构数据接口
     * [异步,必要]
     * @returns
     */
    loadTreeData = async () => {
        const { data } = await apiAction.tree()
        return data
    }

    /**
     * 树节点选中事件
     * [必要]
     * @param {*} id
     */
    onSelectTree(id) {
        this.selectId = id
        this.table.current.onReloadData()
    }

    /**
     * 绑定字典数据
     * @param {*} code
     * @param {*} name
     * @returns
     */
    bindCodeValue(code, name) {
        name = toCamelCase(name)
        const codes = this.state.codes[name]
        if (codes) {
            const c = codes.find(p => p.code == code)
            if (c) {
                return c.value
            }
        }
        return null
    }

    /**
     * 打开新增/编辑弹窗
     * @param {*} modal
     * @param {*} record
     */
    onOpen(modal, record) {
        modal.current.open({
            pid: this.selectId,
            record,
        })
    }

    /**
     * 对表格上的操作进行统一处理
     * [异步]
     * @param {*} action
     * @param {*} successMessage
     */
    async onAction(action, successMessage) {
        this.table.current.onLoading()
        try {
            await action
            Message.success(successMessage)
            this.table.current.onReloadData()
        } catch {
            this.table.current.onLoaded()
        }
    }

    /**
     * 删除
     * @param {*} record
     */
    onDelete(record) {
        this.onAction(apiAction.delete(record), '删除成功')
    }

    //#region 自定义方法
    //#endregion

    render() {
        return (
            <QueryTreeLayout
                loadData={this.loadTreeData}
                defaultExpanded={true}
                onSelect={key => this.onSelectTree(key)}
            >
                <Container mode="fluid">
                    <Card bordered={false}>
                        <QueryTable
                            ref={this.table}
                            autoLoad={false}
                            loadData={this.loadData}
                            columns={this.columns}
                            queryInitialValues={{
                                type: 2,
                            }}
                            query={
                                <Auth auth="sysDict:page">
                                    <Form.Item label="类型名称" name="name">
                                        <Input autoComplete="off" placeholder="请输入类型名称" />
                                    </Form.Item>
                                    <Form.Item label="唯一编码" name="code">
                                        <Input autoComplete="off" placeholder="请输入唯一编码" />
                                    </Form.Item>
                                    <Form.Item label="类型" name="type">
                                        <Radio.Group>
                                            <Radio.Button value={1}>目录</Radio.Button>
                                            <Radio.Button value={2}>字典类型</Radio.Button>
                                        </Radio.Group>
                                    </Form.Item>
                                </Auth>
                            }
                            operator={
                                <Auth auth="sysDict:add">
                                    <Button
                                        icon={<AntIcon type="plus" />}
                                        onClick={() => this.onOpen(this.addForm)}
                                    >
                                        新增{name}
                                    </Button>
                                </Auth>
                            }
                            expandable={{
                                expandedRowRender: record => <DictData type={record} />,
                                rowExpandable: record => !!record.code,
                            }}
                        />
                    </Card>
                </Container>
                <ModalForm
                    title={`新增${name}`}
                    action={apiAction.add}
                    ref={this.addForm}
                    onSuccess={() => this.table.current.onReloadData()}
                >
                    <FormBody />
                </ModalForm>

                <ModalForm
                    title={`编辑${name}`}
                    action={apiAction.edit}
                    ref={this.editForm}
                    onSuccess={() => this.table.current.onReloadData()}
                >
                    <FormBody />
                </ModalForm>
            </QueryTreeLayout>
        )
    }
}
